package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.PaymentTradeService;
import com.gxwebsoft.shop.entity.PaymentTrade;
import com.gxwebsoft.shop.param.PaymentTradeParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 第三方支付交易记录表控制器
 *
 * @author 科技小王子
 * @since 2022-12-09 13:59:38
 */
@Api(tags = "第三方支付交易记录表管理")
@RestController
@RequestMapping("/api/shop/payment-trade")
public class PaymentTradeController extends BaseController {
    @Resource
    private PaymentTradeService paymentTradeService;

    @PreAuthorize("hasAuthority('shop:paymentTrade:list')")
    @OperationLog
    @ApiOperation("分页查询第三方支付交易记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<PaymentTrade>> page(PaymentTradeParam param) {
        PageParam<PaymentTrade, PaymentTradeParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(paymentTradeService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(paymentTradeService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:paymentTrade:list')")
    @OperationLog
    @ApiOperation("查询全部第三方支付交易记录表")
    @GetMapping()
    public ApiResult<List<PaymentTrade>> list(PaymentTradeParam param) {
        PageParam<PaymentTrade, PaymentTradeParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(paymentTradeService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(paymentTradeService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:paymentTrade:list')")
    @OperationLog
    @ApiOperation("根据id查询第三方支付交易记录表")
    @GetMapping("/{id}")
    public ApiResult<PaymentTrade> get(@PathVariable("id") Integer id) {
        return success(paymentTradeService.getById(id));
        // 使用关联查询
        //return success(paymentTradeService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:paymentTrade:save')")
    @OperationLog
    @ApiOperation("添加第三方支付交易记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody PaymentTrade paymentTrade) {
        // 记录当前登录用户id、租户id、商户编号
        User loginUser = getLoginUser();
        if (loginUser != null) {
          paymentTrade.setUserId(loginUser.getUserId());
          paymentTrade.setMerchantCode(getMerchantCode());
        }
        if (paymentTradeService.save(paymentTrade)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTrade:update')")
    @OperationLog
    @ApiOperation("修改第三方支付交易记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody PaymentTrade paymentTrade) {
        if (paymentTradeService.updateById(paymentTrade)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTrade:remove')")
    @OperationLog
    @ApiOperation("删除第三方支付交易记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (paymentTradeService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTrade:save')")
    @OperationLog
    @ApiOperation("批量添加第三方支付交易记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<PaymentTrade> list) {
        if (paymentTradeService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTrade:update')")
    @OperationLog
    @ApiOperation("批量修改第三方支付交易记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<PaymentTrade> batchParam) {
        if (batchParam.update(paymentTradeService, "trade_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:paymentTrade:remove')")
    @OperationLog
    @ApiOperation("批量删除第三方支付交易记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (paymentTradeService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
